# 综合设计与实践A(2024)

## 课程简介

[课程大纲](./course_brief.md)

[课程时间安排](./timeline.md)

[课程资源](./resource.md) 内有课程录屏。

[课程所需软件列表](./tool_chain.md)

[本地软件仓库](https://git.tongji.edu.cn/cdpa/tools_repo)(外网下不了的同学可以在这里找找)

[大作业报告模板](./ppt/综合实验报告模板.doc)

## 文档

课件PPT：

[1.电子电路系统设计方法学.pptx](./ppt/1.电子电路系统设计方法学.pptx)

[2.元器件的识别与选用.pptx](./ppt/2.元器件的识别与选用.pptx)

[3.电子电路系统仿真与仿真软件TINA.pptx](./ppt/3.电子电路系统仿真与仿真软件TINA.pptx)

[6.STM32G030minisys单片机最小系统](./ppt/6.STM32G030minisys单片机最小系统.pptx)

[8.STM32进阶开发](./ppt/8.STM32单片机进阶开发.pptx)

## 作业

[1.设计思考](./work/ex1_design_mindmap.md)

[2.PN结测温电路仿真](./work/ex2_pn_simulation.md)

[3a.基于PN结测温的数字温度计原型系统设计制作与验证——自动化专业](./work/ex3a_digital_thermometer_pnj.md)

[3b.基于NTC的数字显示温度计原型系统设计制作与验证——人工智能专业](./work/ex3b_digital_thermometer_ntc.md)




## 综合项目基础课题

[1. 基于PN结测温原理的数字显示温度计——自动化专业](./project/bp1_digital_thermometer_pn.md)

[2. 基于NTC测温的数字显示温度计——人工智能专业](./project/bp2_digital_thermometer_ntc.md)

★★[大作业元器件清单](./project/material_list.md)

★★[PCB设计检查清单](./project/checklist.md)

## 综合项目申优课题

[1. 简易交流电参数测量仪](./project/ext1_ac_measure.md)

[2. 基于STM32G0与SimpleFOC库的无刷直流电机驱动器（自动化专业推荐）](./project/ext2_motor_foc.md)

[3. 基于STM32G0与NE555的纸张厚度传感器](./project/ext3_paper_sensor.md)

[4. 基于STM32G0的双轮迷宫机器鼠](./project/ext4_mouse.md)

[5. 基于STM32G0及红外反射传感器的手势识别器（人工智能专业推荐）](./project/ext5_gesture.md)

[6. 电子设计竞赛](./project/ext6_contest.md)

## 参考

### 电路设计相关

★★ minisys-stm32g030电路原理图：[minisys-stm32g030_sch_v1p35.pdf](./ref/minisys-stm32g030_sch_v1p35.pdf)

★★ 基于NTC的数字显示温度计参考电路: [ntc_thermometer_sch.pdf](./ref/ntc_thermometer_sch.pdf)

★★ 无刷电机功率驱动部分的参考电路[bldc_pwr_drv_sch_v1p0.pdf](./ref/bldc_pwr_drv_sch_v1p0.pdf)

★★ 手势传感器参考电路[gesture_demo_sch_v1p0.pdf](./ref/gesture_demo_sch_v1p0.pdf)

USB转串口转换器CH340N手册: [CH340DS1.PDF](./ref/CH340DS1.PDF)

基准电压参考TL431手册:[tl431.pdf](./ref/tl431.pdf)

运算放大器LM358手册: https://www.ti.com/lit/ds/symlink/lm358.pdf

低压差（LDO）线性稳压器AMS1117手册：http://www.advanced-monolithic.com/pdf/ds1117.pdf



### 单片机开发相关

[Linux环境下开发STM32流程](./stm32_dev_on_linux.md)

[LED数码管显示例程(基于Keil MDK)](./examples/g030_display)

[G030内置ADC单次采样例程(基于Keil MDK)](./examples/g030_adc)

[G030内置ADC连续采样例程(基于Keil MDK)](./examples/g030_adc_conti)

[G030内置ADC连续采样+串口发送例程(基于Keil MDK)](./examples/g030_adc_uart)

[如何在CMakeLists.txt中添加自己的代码文件](./how-to/add_src_to_cmakelists.md)

[openocd无法连接cmsis-dap的解决方法](./how-to/openocd_issues_solution.md)

[如何解决Ubuntu Linux下STM32CubeMX菜单显示不全的问题](./how-to/fix_cubemx_display_issue_under_ubuntu.md)




### 元件库

使用方法：[KiCAD原理图库及PCB封装库的管理与维护](./lib_manipulation.md)

库文件下载：

光电对射传感器ITR20001原理图库和封装库 [ITR20001_kicad.zip](./lib/itr20001_kicad.zip)

接插件MXB-5A的封装库[MXB15001LT-05A.kicad_mod](./lib/pcb/MXB15001LT-05A.kicad_mod)

接插件XHB-3A的封装库[XHB-3A-2.50mm.kicad_mod](./lib/pcb/XHB-3A-2.50mm.kicad_mod)



