# 课程大纲

## 课程教学目标：

综合设计与实践A这门课程是面向二年级同学，针对三年级各专业课程中的专业综合创新设计实践/大作业设置的前置基础性技能实践课程。通过本课程的学习，同学应能够掌握电子电路系统及嵌入式系统的工程设计、实现及调试方法，掌握“全栈”开发能力，并使之能够应用于自动化、电气、电子科学、电子信息、通信工程等多个专业的专业课程实践（例如“大作业”）与创新环节中，为同学们在上述课程、实践、创新环节中提供良好技能基础，使同学们能够把主要精力用于将专业理论转化为系统化、工程化的专业实践与创新作品。

本课程通过循序渐进的多个综合设计案例，旨在掌握以下几个方面的知识和技能：

- 电子电路与嵌入式系统设计方法学
- 电子元器件的识别与选型
- 电子电路系统仿真
- 电子电路系统硬件设计流程及电路设计软件KiCAD的使用方法
- 嵌入式系统软件设计流程及STM32单片机外设接口的使用方法
- 基于STM32单片机的嵌入式系统综合设计

通过本课程的学习，同学应掌握综合性的电子电路与嵌入式系统硬件及软件设计方法，通过工程化的方法，完成一个具有一定功能的、可独立运行的嵌入式系统作品。由于课时限制，本课程无法深入探讨各个知识点的体系架构和细节，但课程的核心目的是从全局角度，构建电子电路与嵌入式系统工程设计的知识体系主干。

## 课程设置及主要内容：


|课时|课程内容|教学目标|
|----|----|----|
|1|电子电路系统的设计方法学|了解电子电路系统的一般性设计流程|
|2|电子元器件的识别与选型|掌握电阻、电容、二极管、三极管的识别，了解各种元器件参数的意义，掌握电路设计中元器件选型的方法|
|3|电子电路系统仿真|学习TinaTI电路仿真软件的使用方法|
|4|电子电路系统仿真实验|利用TinaTI电路仿真软件进行模拟电路设计（课题：基于PN结的温度传感器及其信号调理电路）|
|5|单片机应用系统构成与外围硬件设计|学习单片机应用系统的硬件构成及设计方法|
|6-7|电子电路系统软件设计流程及STM32单片机开发|了解电子电路系统中的软件设计的一般性流程与方法，学习STM32单片机系统开发软件的使用方法（VSCode + GCC + openOCD代码编写与调试），掌握STM32 CubeMX代码生成工具的使用方法，掌握STM32单片机GPIO、中断、定时器、定时器高级功能（捕获、PWM）、模数转换器（ADC）、UART的使用|
|8-9|综合实验(一)|基于miniSYS板+自行搭建的的数码管显示模块，使用STM32定时器、GPIO资源编写一个秒计时器程序，使得数码管能够显示秒数|
|10-13|电子电路系统软件设计流程及STM32单片机开发实验（综合实验二）|**与所在小班老师讨论作品选题，并利用现有的minisys板和原材料，使用万用板（洞洞板）完成作品硬件电路原型的搭建，编写程序，完成初步的功能验证。**|
|14|电子电路系统硬件设计流程及电路设计软件KiCAD（一）|了解单片机系统硬件设计的一般性流程与方法，学习使用KiCAD进行单片机系统的电路原理图设计与印刷电路板设计|
|15|电子电路系统硬件设计流程及电路设计软件KiCAD（二）|学习使用KiCAD进行单片机系统设计，了解印刷电路板生产工艺及工艺参数。|
|16-21|综合实验（三）|要求：使用KiCAD设计一个包含全系统的单一电路板，除了温度传感器外，其他元器件（包括单片机及其周边电路、LED显示、按键、模拟信号处理部分）必须都设计在该电路板上；完成印刷电路板设计，并交由工厂加工，电路板设计文件必须在规定时间节点前提交|
|22|嵌入式系统数据通信方法|学习使用单片机的串行口将数据发送至PC机，PC端使用C++/Python等语言编写软件接收上述数据，以文件形式记录，并使用图形界面显示当前温度数据。|
|23|单片机系统软件|介绍常见单片机软件编程技巧|
|24-34|综合实验（四）|领回综合实验（三）提交加工的PCB后完成元器件的焊接、硬件调试、软件调试。可自行完成扩展功能，并完成设计报告撰写。设计报告字数不少于2500字。|

## 考察及成绩评定方法：
|项目|分数占比（%）|说明|
|----|----|----|
|出勤|10||
|阶段性成果提交|30|综合实验（一）、（二）对应作业完成情况|
|综合作业基础课题|40|综合实验（三）基础功能部分，按照基础功能完成情况打分|
|综合作业申优课题附加分|10|综合实验（三）创新功能部分，按照创新功能完成情况打分|
|综合作业报告|10|报告评价标准：格式规范、原理正确、描述清晰、实验数据完整|
**说明：选做综合作业申优课题直接按照总分50%计算，不再要求制作综合作业的基础课题**

