## 如何解决ubuntu linux下STM32CubeMX菜单显示不全的问题



在终端中输入：

```shell
echo $XDG_SESSION_TYPE
```

查看当前使用的window系统，默认是wayland，造成显示不正常，需要改成X11显示系统。

在终端中输入：

```shell
sudo vim /etc/gdm3/custom.conf
```

在文件中找到

```
#WaylandEnable=false
```

删除'#'号取消注释

按`ESC`键取消编辑模式，输入`:wq`保存退出vim。

重启ubuntu，在菜单中点击`settings`图标进入ubuntu设置界面，找到`About`页面，查看`Windowing System`一项，应为`X11`，如下图：

![image-20240727102507973](image/image-20240727102507973.png)

再次启动STM32CubeMX时应能正确显示菜单。

![image-20240727102636268](image/image-20240727102636268.png)







---

参考：

https://zhuanlan.zhihu.com/p/699377123

