## 基础课题PCB检查清单



以下每一项内容都需要在提交设计文件之前完成检查

### 一、原理图检查

| 编号 | 项目                   | 检查要点                                                     | 结果 |
| ---- | ---------------------- | ------------------------------------------------------------ | ---- |
| 1    | STM32G030 VDD/VREF供电 | 供电电压3.3V，有0.1uF退耦电容                                |      |
| 2    |                        | VREF使用TL431进行稳压                                        |      |
| 3    |                        | TL431输出端并联的电容容量大于10uF或小于0.1uF                 |      |
| 4    |                        | 按照VBUS电压4.2~5.5V范围考虑，计算TL431的限流电阻阻值，使得通过TL431的A/K两端的电流大于3mA，小于15mA |      |
| 5    | STM32G030调试接口      | 引出PA13（SWDIO）/PA14（SWCLK）两个信号到一个四针排针，同时，排针中有VDD和GND |      |
| 6    |                        | PA14（SWCLK）有10KΩ下拉电阻                                  |      |
| 7    | STM32G030复位电路      | 第10脚NRST有0.1uF电容接地，可选有10K电阻上拉至VDD            |      |
| 8    | LED数码管驱动部分      | 三极管应使用SOT-23封装的NPN型三极管                          |      |
| 9    | USB Type-C插座连接     | VBUS为整板供电输入                                           |      |
| 10   |                        | CC1、CC2接5.1KΩ下拉电阻                                      |      |
| 11   |                        | 插座的D+与CH340N的UD+管脚正确连接                            |      |
| 12   |                        | 插座的D-与CH340N的UD-管脚正确连接                            |      |
| 13   |                        | 插座的两个D+相连，两个D-相连                                 |      |
| 14   |                        | USB Type-C插座的固定脚接地                                   |      |
| 15   | CH340N部分             | V3和VCC引脚一起连接至VDD（3.3V）                             |      |
| 16   |                        | 有0.1uF退耦电容                                              |      |
| 17   |                        | CH340N的TXD接MCU的PA10(UART_RX)，CH340N的RXD接MCU的PA9(UART_TX) |      |
| 18   | 稳压器AMS1117-3.3      | VI/VO引脚各有一个0.1uF退耦电容，VI另有一个10uF退耦电容       |      |
| 19   | 模拟电路部分           | LM358使用5V(VBUS)供电，有一个0.1uF退耦电容                   |      |
| 20   |                        | 仿真确认LM358所有的输入输出引脚在任何情况下电压不超过3.5V    |      |
| 21   | 原理图ERC              | 使用KiCAD的原理图编辑器中的ERC检查不应有error                |      |
| 22   |                        | 所有元件应完成封装的指定                                     |      |
| 23   |                        | 除LED数码管和部分接插件外，所有元器件应为贴片封装            |      |
| 24   |                        | 所有元器件应有型号/取值，除非待调整的电阻                    |      |



### 二、PCB设计检查

| 编号 | 项目                                                | 要求                                                         | 结果 |
| ---- | --------------------------------------------------- | ------------------------------------------------------------ | ---- |
| 25   | PCB设计规则设置(Board Setup/Constraints)            | 最小间距：0.2mm                                              |      |
| 26   |                                                     | 最小线宽：0.2mm                                              |      |
| 27   |                                                     | 最小连接宽度：0.2mm                                          |      |
| 28   |                                                     | 最小环宽：0.15mm                                             |      |
| 29   |                                                     | 最小过孔盘直径：0.6mm                                        |      |
| 30   |                                                     | 最小通孔直径：0.3mm                                          |      |
| 31   | PCB层数(Board Setup/Physical Stackup/Copper layers) | 2层                                                          |      |
| 32   | PCB尺寸                                             | 具有规范的板框图形，在Edge Cuts层，外形尺寸最大100mmx100mm   |      |
| 33   | 元器件布局检查                                      | LED数码管正置（方形焊盘为1脚，应在封装左下方）               |      |
| 34   |                                                     | USB Type-C插座贴边朝外（没脚的一边贴板子边缘）               |      |
| 35   |                                                     | 没有元器件重叠覆盖                                           |      |
| 36   |                                                     | 退耦电容尽量靠近所属芯片的对应电源管脚                       |      |
| 37   |                                                     | 晶振靠近单片机放置                                           |      |
| 38   |                                                     | 调试接口周围没有较高的元件遮挡干涉                           |      |
| 39   |                                                     | CH340N靠近USB Type-C插座                                     |      |
| 40   |                                                     | 运放电路附属的电阻应尽量靠近运放                             |      |
| 41   |                                                     | 侧向接线的接插件接线侧朝外                                   |      |
| 42   | 布线                                                | 反面整块地线铺铜                                             |      |
| 43   |                                                     | 电源线（VBUS、VDD等）主干走线宽度不小于1mm，芯片引出的部分尽可能短粗 |      |
| 44   |                                                     | USB相关信号线不能有交叉、过孔                                |      |
| 45   |                                                     | 走线交汇处不应出现锐角                                       |      |
| 46   |                                                     | 走线转弯处应走135度转角                                      |      |
| 47   | 丝印                                                | 元件标号应尽量统一方向                                       |      |
| 48   |                                                     | 元件标号不能覆盖焊盘或与其他丝印重叠                         |      |
| 49   |                                                     | 必要的接插件标注信号，且标识清晰                             |      |
| 50   |                                                     | 板子正面印有姓名学号等信息                                   |      |
| 51   | 设计规则检查（Inspect/Design Rules Checker）        | 不能有Errors                                                 |      |
| 52   |                                                     | 不能有Unconnected Items                                      |      |
| 53   | 光绘                                                | 各层文件完整（F.Cu, B.Cu, F.Silkscreen, B.Silkscreen, F.Mask, B.Mask, Edge.Cuts, PTH drill, NPTH drill ） |      |
| 54   |                                                     | 嘉立创下单助手中的PCB预览图符合设计预期                      |      |



### 下单注意事项



1、每个人PCB制作预算限35元含邮费

2、样板生产数量统一为5片

3、下单请注明开票信息：

​	抬头：同济大学

​	税号：12100000425006125J

​	如超预算或以上信息填写错误，恕无法报销

4、PCB打样仅限一次，如有问题返工，请自行付费

5、PCB打样供应商有两家可选：

​	嘉立创：https://www.jlc.com/

​	杭州捷配：https://www.jiepei.com/

​	可自行根据预算和交期选择

