## 简易交流电参数测量仪

### 任务

使用STM32单片机配合模拟电路对交流电的参数进行测量。最终提交的成果包括能够完成以下功能的电路板组件和设计报告。



### 技术要求

1. 基于STM32G030C8单片机，设计一款交流信号频率特性分析仪。
2. 该信号特性分析仪可以完成以下功能：

- 测量50Hz交流信号的电压、电流有效值、峰峰值

- 测量的交流电压有效值不大于15V，电流有效值不大于2A

- 可以分析电压、电流的谐波分量（最高7次谐波）

- 数据通过串口发送至计算机

- 可选使用图形界面显示各个参数

- 可选使用图形界面显示电压电流波形

### 说明

- 交流信号可使用变压器将市电降至12V

- 电流的采集使用小型交流互感器，电压采集可以使用电阻分压

- 务必保证输入的信号经过调理，其极限值不超过单片机ADC的容许范围

- 谐波分析可在单片机中计算，也可以传输至计算机处理

- 电压电流需要在数码管上轮流显示，或者使用按键来切换



### 报告

报告应包含：

##### 1、完整的电路原理图

##### 2、PCB版图

##### 3、电路原理的描述（模拟电路原理描述，计算，minisys板的原理介绍）

##### 4、模拟电路部分的仿真结果

##### 5、单片机软件的框架结构及工作原理，部分关键性代码

##### 6、实验测试结果

##### 7、作品的完整照片或视频和测试过程中的照片。



### 评分（总分60）

|     项目     | 分项                            | 分值 | 要求                                                   |
| :----------: | ------------------------------- | ---- | ------------------------------------------------------ |
| 模拟电路设计 | 电压采集信号调理                | 5    | 报告中有电压采集调理电路原理描述及参数计算             |
|              | 电流采集信号调理                | 3    | 报告中有电流采集调理电路原理描述及参数计算             |
|              | 误差分析                        | 2    | 报告中有关于交流电参数的实测数据及误差分析             |
|  单片机设计  | ADC采集的程序设计原理           | 8    | 包括ADC转换公式、ADC采集程序流程、数据存储             |
|              | 电压/电流参数测量与计算算法原理 | 10   | 电压电流参数的计算（有效值计算、峰峰值计算）           |
|              | 标定/拟合流程                   | 2    | 有误差修正过程或算法                                   |
|              | 谐波分析                        | 5    | 谐波分析的实现及算法                                   |
|     PCB      |                                 | 10   | 符合生产工艺要求和设计技术要求，布局合理，布线规范美观 |
|   数据通信   |                                 | 5    | 单片机能够以规定的速率发送温度数据，并在PC端显示       |
|     报告     | 格式                            | 2    | 按照模板要求，公式、描述规范                           |
|              | 原理描述                        | 5    | 原理描述完整，图表清晰                                 |
|              | 测试过程与数据                  | 3    | 测试过程有记录，有数据，有分析                         |





### 注意事项

*本作业最终的成果必须是PCB组件。*

提交时请将报告和视频/照片打包上传，大小不要超过10MB。报告请按照《综合实验报告模板》撰写，字数不少于2500字.