## 纸张厚度传感器

### 任务

使用STM32单片机NE555定时器芯片对一叠A4纸的厚度（张数）进行测量。最终提交的成果包括能够完成以下功能的电路板组件和设计报告。



### 技术要求

1. 基于STM32G030C8单片机。
2. 使用NE555芯片，设计多谐振荡电路，利用夹住纸张的两个极板构成的电容变化改变输出频率。
3. 使用LED数码管进行数据显示。
4. 具有串口通信能力，以接住计算机完成数据校准。
5. 测量范围：1~50张纸，要求误差不大于+/-5张
6. 整个电路使用USB口5V供电



### 说明

- 利用夹住纸张的极板构成的电容随着纸张厚度发生变化的原理进行测量

- 需要自行设计测量用极板结构，可使用覆铜板作为极板，极板可以接触纸张

- 单个极板的面积不大于10x10cm

- 利用NE555多谐振荡电路产生不同频率的信号，使用单片机定时器测量信号频率

- 可根据技术需求，使用NE555功能类似的芯片替代

- 一键启动测量，并在5秒内显示测量结果

  

### 报告

报告应包含：

##### 1、完整的电路原理图

##### 2、PCB版图

##### 3、电路原理的描述（模拟电路原理描述，计算，minisys板的原理介绍）

##### 4、模拟电路部分的仿真结果

##### 5、单片机软件的框架结构及工作原理，部分关键性代码

##### 6、实验测试结果

##### 7、作品的完整照片或视频和测试过程中的照片。



### 评分（总分60）

|     项目     | 分项                           | 分值 | 要求                                                   |
| :----------: | ------------------------------ | ---- | ------------------------------------------------------ |
| 模拟电路设计 | 纸张厚度测量原理分析与电路设计 | 5    | 报告中有测量原理的描述及参数计算                       |
|              | 电源电路设计                   | 2    | 报告中有供电部分的设计描述及参数计算                   |
|              | 误差分析                       | 3    | 报告中有关于纸张厚度（张数）的实测数据及误差分析       |
|  单片机设计  | 信号频率测量的程序设计原理     | 10   | 包括定时器测量原理、集程序流程、数据存储               |
|              | 标定算法                       | 10   | 详细阐述如何修正测量误差                               |
|              | 数据显示与人机交互             | 5    | 具有按键控制测量、数据显示                             |
|     PCB      |                                | 10   | 符合生产工艺要求和设计技术要求，布局合理，布线规范美观 |
|   数据通信   |                                | 5    | 单片机能够与PC交互，并且能够在测量后输出测量数据       |
|     报告     | 格式                           | 2    | 按照模板要求，公式、描述规范                           |
|              | 原理描述                       | 5    | 原理描述完整，图表清晰                                 |
|              | 测试过程与数据                 | 3    | 测试过程有记录，有数据，有分析                         |





### 注意事项

*本作业最终的成果必须是PCB组件。*

提交时请将报告和视频/照片打包上传，大小不要超过10MB。报告请按照《综合实验报告模板》撰写，字数不少于2500字.