## 基于STM32G0的双轮迷宫机器鼠

### 任务

使用STM32G0单片机配合DRV8870DDA有刷电机驱动芯片及若干ITR20001/TR24红外对射传感器，利用指定的成品双轮车套件，构建一个双轮迷宫机器鼠，可实现前进、后退、变速、原地转向、行进转向、避障、巡线等功能。最终提交的成果包括能够完成上述功能的包含电路板组件的机器鼠模型和设计报告。



### 技术要求

1. 基于STM32G030C8单片机。
   
2. 所有电路应设计在一张PCB上，不得用插接模块。
   
3. 该迷宫机器鼠应满足以下要求：

- 采用6V直流供电（使用电池或实验电源/电源适配器），如使用电源可以使用长线连接作品。

- 使用两片DRV8837DSG驱动器，分别控制左右两个有刷直流电机

- 使用8个ITR20001/TR24红外对射传感器，其中4个用于避障，4个用于巡线。红外对射传感器使用单片机ADC采集反射亮度。

- 需要自行设计电源部分电路，将电机用12V电源转换为单片机使用的3.3V电源。考虑到电源效率，推荐使用TPS562201DDCR降压开关稳压器。
  
- 自行设计的PCB应具备合适的安装孔，以固定到机械鼠底盘。



### 说明

- 实验室提供双轮机械鼠底盘及电机。类似下图所示：

  ![image-20240712101634872](./ext4_mouse_image/image-20240712101634872.png)

  

- DRV8837DSG的参考资料：https://www.ti.com/lit/ds/symlink/drv8837.pdf

- TPS562201DDCR的参考资料：https://www.ti.com/lit/ds/symlink/tps562201.pdf
  
- 功能演示须自行搭建小型测试场景，比如巡线测试使用白色KT板上粘贴20~25mm宽黑色胶带，避障可以自行设置简单障碍物。



### 报告

报告应包含：

##### 1、完整的电路原理图

##### 2、PCB版图

##### 3、电路原理的描述（原理描述，计算，G030如何驱动或采集）

##### 4、单片机软件的框架结构及工作原理，部分关键性代码

##### 5、实验测试结果

##### 6、作品的完整照片或视频和测试过程中的照片。



### 评分（总分60）

|     项目     | 分项                                  | 分值 | 要求                                                   |
| :----------: | ------------------------------------- | ---- | ------------------------------------------------------ |
| 模拟电路设计 | 电机功率驱动的实现，须实现 调速、换向 | 7    | 报告中有相关部分的原理描述及参数计算                   |
|              | 电源部分设计实现                      | 3    | 报告中有电流采集调理电路原理描述及参数计算             |
|  单片机设计  | PWM信号生成及电机换向的实现           | 10   | 详细描述实现原理                                       |
|              | 使用ADC采集红外对射传感器的原理       | 10   | 包括ADC转换公式、ADC采集程序流程、有参数的计算         |
|     PCB      |                                       | 10   | 符合生产工艺要求和设计技术要求，布局合理，布线规范美观 |
|     算法     | 避障算法实现                          | 5    |                                                        |
|              | 巡线算法实现                          | 5    |                                                        |
|     报告     | 格式                                  | 2    | 按照模板要求，公式、描述规范                           |
|              | 原理描述                              | 5    | 原理描述完整，图表清晰                                 |
|              | 测试过程与数据                        | 3    | 测试过程有记录，有数据，有分析                         |





### 注意事项

*本作业最终的成果必须是PCB组件。*

提交时请将报告和视频/照片打包上传，大小不要超过10MB。报告请按照《综合实验报告模板》撰写，字数不少于2500字.