## 基于STM32G0及红外对射传感器的手势识别器（人工智能专业推荐）

### 任务

使用STM32G0单片机及16个ITR20001/TR24红外对射传感器，在一块不大于15x15cm大的PCB上完成一个手势识别器，可以感知靠近板子处放置的“石头”、“剪刀”、“布”手势，并以LED亮灯的形式显示判断结果。最终提交的成果包括能够完成上述功能的包含电路板组件和设计报告。



### 技术要求

1. 基于STM32G030C8单片机。
2. 所有电路应设计在一张PCB上，不得用插接模块。
3. 该传感器使用USB口与计算机通信及取电。
   - 使用USB Type-C接插件
   - 使用CH340N完成USB转串口的协议转换
4. 红外对射传感器的反射强度可通过使用ADC采集接收端光电流获得
5. 使用16个ITR20001/TR24红外对射传感器，均匀分布在PCB上，推荐4x4排列，也可以采用均匀的随机排布
6. 使用3个LED用来显示手势结果



### 说明

- 16个ITR20001/TR24

- ADC通道不够的问题可以通过分时切换采集解决

  



### 报告

报告应包含：

##### 1、完整的电路原理图

##### 2、PCB版图

##### 3、电路原理的描述（原理描述，计算，G030如何驱动或采集）

##### 4、单片机软件的框架结构及工作原理，部分关键性代码

##### 5、实验测试结果

##### 6、作品的完整照片或视频和测试过程中的照片。



### 评分（总分60）

|     项目     | 分项                                        | 分值 | 要求                                                         |
| :----------: | ------------------------------------------- | ---- | ------------------------------------------------------------ |
| 模拟电路设计 | 手势采集原理及传感器阵列的设计              | 7    | 报告中有相关部分的原理描述及参数计算                         |
|              | 电源及USB接口部分设计实现                   | 3    | 报告中有电路原理描述及参数计算                               |
|  单片机设计  | 多通道数据采集的实现                        | 10   | 详细描述实现原理，包括ADC转换公式、ADC采集程序流程、有参数的计算 |
|              | 手势数据的生成、组织和传输                  | 10   | 介绍上位机（PC）如何获得手势数据的原理及流程                 |
|     PCB      |                                             | 10   | 符合生产工艺要求和设计技术要求，布局合理，布线规范美观       |
|     算法     | 在PC上利用K-Means算法实现手势的推理判别     | 6    | 训练、推理流程在PC上实现，将结果推送至单片机并显示           |
|              | 在单片机上利用K-Means算法实现手势的推理判别 | 4    | 训练过程在PC上实现，推理过程在单片机上实现                   |
|     报告     | 格式                                        | 2    | 按照模板要求，公式、描述规范                                 |
|              | 原理描述                                    | 5    | 原理描述完整，图表清晰                                       |
|              | 测试过程与数据                              | 3    | 测试过程有记录，有数据，有分析                               |





### 注意事项

*本作业最终的成果必须是PCB组件。*

提交时请将报告和视频/照片打包上传，大小不要超过10MB。报告请按照《综合实验报告模板》撰写，字数不少于2500字.