## 电子设计竞赛

### 任务

本项目可使用课程期间的电子设计竞赛作品作为项目成果提交。



### 技术要求

1. 提交作品必须包含完整的单片机系统。
2. 提交作品必须以自行设计焊接制作的电路板成品提交，并能够演示报告中声明的功能。
3. 提交的作品PCB上必须写有提交者的姓名学号等信息，并提供KiCAD设计的电路图、PCB版图、以提交者下单或支付的PCB订单信息。
4. 提交的成果需包含所有的设计文件，包括并不限于电路图、PCB版图、软件源代码、设计报告、测试报告等。
5. 需提交竞赛文件以证明竞赛作品制作时间与本课程时间重叠。
6. 需提交竞赛正式报名文件（本科生院盖章）复印件或扫描件。



### 报告

报告应包含：

##### 1、完整的电路原理图

##### 2、PCB版图

##### 3、电路原理的描述（模拟电路原理描述，计算，单片机系统的原理介绍）

##### 4、模拟电路部分的仿真结果

##### 5、单片机软件的框架结构及工作原理，部分关键性代码

##### 6、实验测试结果

##### 7、作品的完整照片或视频和测试过程中的照片。



### 评分（总分60）

|      项目      | 分项                                 | 分值 | 要求                                                         |
| :------------: | ------------------------------------ | ---- | ------------------------------------------------------------ |
|    电路设计    | 具备完整的信号调理电路或通信接口电路 | 15   | 具有自行设计模拟/数字电路，包含但不限于模拟运输电路，总线拓展，传感器（温度、光照、图像等），通信接口， |
|                | 独立的供电设计                       | 5    | 具有自行设计供电电路，不限于升压、降压、充电等电路           |
| 单片机系统设计 | 单片机系统设计                       | 15   | 具有完整的单片机应用系统，能够独立完成较为复杂的功能，包括但不限于数据采集、信号处理、人机交互、自动控制等 |
|      PCB       |                                      | 10   | 符合生产工艺要求和设计技术要求，布局合理，布线规范美观       |
|    获奖证明    |                                      | 5    | 获得省级及以上奖项的得分，须提供获奖证明（证书、组委会公告等官方认可的形式），限三等奖及以上 |
|      报告      | 格式                                 | 2    | 按照模板要求，公式、描述规范                                 |
|                | 原理描述                             | 5    | 原理描述完整，图表清晰                                       |
|                | 测试过程与数据                       | 3    | 测试过程有记录，有数据，有分析                               |





### 注意事项

*本作业最终的成果必须是PCB组件。*

提交时请将报告和视频/照片打包上传，大小不要超过10MB。报告请按照《综合实验报告模板》撰写，字数不少于2500字.