## Linux环境下开发STM32流程

### 一、使用STM32CubeMX生成代码框架

略

### 二、添加自己的代码

略

### 三、在VSCode中使用Cmake配置与编译

打开VSCode，使用Open Folder找到项目的目录，这里的目录应为包含CMakeLists.txt的一层。

#### 3.1 使用Cmake配置

按Ctrl+Shift+P呼出VSCode命令面板，输入Cmake:Configure调用cmake进行配置，生成编译脚本。

#### 3.2 使用Cmake编译源码

再按Ctrl+Shift+P呼出VSCode命令面板，输入Cmake:Build，或者按F7键进行编译，观察下方窗口编译的输出情况，正常完成后应该如下图所示：

![image-20240710161926849](./image/image-20240710161926849.png)

如果有错误发生，翻阅编译器输出信息，寻找代码中出错的地方进行修改。

#### 3.3 添加openocd配置文件

在项目根目录添加openocd配置文件。新建一个文本文件，并命名为cmsis-dap.cfg，使用VSCode输入以下内容：

```text-plain
# choose cmsis-dap as the debug probe
source [find interface/cmsis-dap.cfg]

# define the flash size
# STM32G030 has 64kB flash size, which is 0x10000
set FLASH_SIZE 0x10000
source [find target/stm32g0x.cfg]

#download speed = 1MHz
adapter speed 1000
reset_config srst_only
```

保存文件。

 #### 





### 四、在VSCode中基于openocd为STM32配置在线调试

点击VSCode左侧Debug图标，点击“create a launch.json file”，如下图：

![image-20240710162431553](./image/image-20240710162431553.png)

在弹出菜单中选择“C++(GDB/LLDB)”，进入launch.json的文件编辑界面。

在左侧点击"Show all automatic debug configurations"，在弹出的菜单中选择"Cortex Debug: OpenOCD"。

![image-20240710162631877](./image/image-20240710162631877.png)

接着修改文件内容，注意以下需要修改的地方：

- 修改"executable"一行，将可执行文件名修改为刚才cmake编译出的elf文件，注意这里需要包含文件的路径。
- 在"configFiles"一行添加openocd的配置文件，就是3.3节编辑的文件。
- 如果需要，可以在最后添加svdFile选项，帮助你看外设寄存器。

修改好的文件内容应该如下所示：

```json
{
    // Use IntelliSense to learn about possible attributes.
    // Hover to view descriptions of existing attributes.
    // For more information, visit: https://go.microsoft.com/fwlink/?linkid=830387
    "version": "0.2.0",
    "configurations": [
        {
            "cwd": "${workspaceRoot}",
            "executable": "./build/demo.elf",
            "name": "Debug with OpenOCD",
            "request": "launch",
            "type": "cortex-debug",
            "servertype": "openocd",
            "configFiles": [
                "./cmsis-dap.cfg"
            ],
            "searchDir": [],
            "runToEntryPoint": "main",
            "showDevDebugOutput": "none"
        }

    ]
}
```



### 五、调试技巧

完成以上修改后，在Debug工具栏点击下图按钮即可下载固件，开始在线调试STM32.

![image-20240710163314486](./image/image-20240710163314486.png)



程序会停在main函数入口的第一句。这时可以按F10键单步运行，按F11键进入函数（如果停在的位置是一处函数调用的话），按Shift+F11则跳出当前函数运行，按F5全速运行，按F6暂停。

可以在程序代码左侧行号的左边单击鼠标打断点，程序运行到断点就会停下，方便观察变量的变化情况。

注意：CMSIS-DAP和Cortex-M0内核单片机最多支持4个硬件断点，单步运行本身会占用一个硬件断点，使用时需要注意。

VSCode界面左侧从上到下分别是变量区、观察点区、CALL Stack区、断点区。

![image-20240710163855777](./image/image-20240710163855777.png)

- 变量区——用来显示当前运行状态下可观察到所有变量，具体又分Local变量、Global变量、Static变量和Registers寄存器。
- 观察点区——可以手动将代码中的变量添加到观察点区，方法是在代码中的变量名上点击右键，选择“Add to watch”即可。
- CALL Stack区——用来显示目前函数调用的关系
- 断点区——显示当前断点的位置。