# 课程所需软件列表及下载安装方法

### 一、简介

本课程面向电路及嵌入式系统的工程化开发，需要使用的软件较多，请大家课前做好准备。整个开发实验环境根据使用的操作系统不同，所需的计算机硬件需求如下：

For Windows

- CPU: Intel/AMD x64, 4 cores+

- RAM: 8GB+

- HDD/SSD: 20GB+

For Linux

- CPU:  Intel/AMD x64, 4 cores+

- RAM: 10GB+

- HDD/SSD: 40GB+

  

根据开发软件的功能，分为以下几个大类：

#### 基础环境类

用于支持开发软件运行的环境，如：

- 虚拟机（用于在Windows系统中运行其他操作系统），如：VMware Workstation/Oracle Virtual Box
- Ubuntu Linux

#### 电路仿真与电路设计类

电路仿真软件：

- TINA

电路设计软件：

- KiCAD

PCB生产用：

- 嘉立创下单助手



#### 嵌入式系统开发类

STM32代码生成工具：

- STM32CubeMX

单片机编译器：

- GCC for ARM

上位机编译器：

- GCC
- Python

代码编辑：

- VSCode
- vim

版本管理：

- Git

编译工程管理：

- CMake

- make

  

#### 调试工具类

在线调试支持：

- OpenOCD

串口调试工具：

- SSCOM
- screen
- cutecom
- minicom

----

### 二、开发环境的选择

本课程所使用的工具，除了TINA外，其他所有的开发环节都可以在Windows或Linux环境下运行。但是开源嵌入式软件开发在linux下更加方便，特别是基于GCC和CMake的流程，在Linux下无比顺畅，而在Windows下需要花很大的精力维护调试。此外，考虑到下学期有很多的课程的实验、大作业需要使用Linux环境，比如芯片设计和图像处理课程，因此推荐大家软件开发的流程尽早使用Linux。

在此我推荐使用以下方案：

**硬件开发相关的TINA、KiCAD、嘉立创下单助手可以使用基于Windows的版本；**

**软件开发相关的可以使用Linux版本，并通过虚拟机安装Ubuntu。**

如果你实在对Linux不熟悉，或者你的电脑RAM只有8GB，或者你的硬盘空间紧张，不够跑虚拟机，我也准备了Windows环境下的嵌入式软件开发环境的说明，见第五节

www.runoob.com



----

### 三、硬件开发工具的下载安装

**TINA:**

下载链接：

https://git.tongji.edu.cn/cdpa/tools_repo/-/raw/main/hw_dev/Tina90-TIen.exe

安装：

双击下载的exe文件，然后一路Next即可。



**KiCAD:** 

当前版本：8.0.3

官方主页：https://www.kicad.org

for Windows x64下载链接：

https://mirror.tuna.tsinghua.edu.cn/kicad/windows/stable/kicad-8.0.3-x86_64.exe

https://mirrors.aliyun.com/kicad/windows/stable/kicad-8.0.3-x86_64.exe

KiCAD for Windows x64的安装：

双击下载的exe文件，然后一路Next即可。注意，KiCAD默认装在C盘，一定不要更改盘符，否则后期使用时会出现很多问题。



for Linux x64下载：

Ubuntu Linux系统中不用单独下载，只需要在Terminal中执行以下命令：

```
sudo add-apt-repository ppa:kicad/kicad-8.0-releases
sudo apt update
sudo apt install kicad
```

或者在Ubuntu 软件市场中也能找到KiCAD



**嘉立创下单助手：**

当前版本：5.1.10(Win64)/5.0.69(Linux)

官方主页：https://www.jlc.com/

for Windows x64下载链接：https://download.jlc.com/jlchelper/release/5.1.10/JLCPcAssit_setup_5.1.10.zip

解压已下载的zip文件，双击解压出来的exe文件，然后一路Next即可。

for Linux x64下载链接：https://download.jlc.com/pcAssit/5.0.69/JLCPcAssit-linux-x64-5.0.69.zip



---

### 四、基于Linux的嵌入式软件开发环境的准备

#### 4.1 前言

为什么要在Linux下进行嵌入式系统的开发？

- 配合虚拟机可以安装多个Linux系统，实现开发环境独立（多个开发平台共用一个系统会有很多问题）
- Linux具有更加完善方便的软件包管理机制
  - apt
  - debian package
- Linux下使用开源/免费工具链更加方便
  - 免费的gcc、clang编译器
  - 免费的vim/emacs/eclipse/vscode
  - cmake/make/ninja
- Linux更适合大规模项目的开发
  - 多用户
  - 基于Git的协同开发
  - 在HPC/Server上开发
- 很多的嵌入式系统开发工作在Linux下具有统一或相似的开发流程和使用习惯
  - STM32开发
  - RISC-V开发
  - CV相关的开发
  - IC设计
  - AI应用
  - 上位机软件开发
- Linux支持更多的主机平台
  - x64（Intel/AMD/Zhaoxin）
  - ARM（RaspberryPi，Hisilicon）
  - LoongArch（龙芯）
- 目前，Linux下的嵌入式开发已经基本成熟，开源生态完善
  - Linux环境下支持几乎大部分主流嵌入式系统的开发，只要gcc支持，linux就可以支持。
- 被卡脖子的情况很难发生



#### 4.2 安装虚拟机

Linux安装有两种方式：

- 裸机安装（安装在一台未安装操作系统的计算机上）
- 虚拟机安装（通过VMware/Virtual Box等虚拟机软件安装）

如果你有一台空闲的计算机，那么可以选择裸机安装，具体方法见ubuntu网站：https://ubuntu.com/download/desktop#how-to-install

这里推荐虚拟机安装。

首先，准备虚拟机软件，推荐使用vmware workstation， 这个软件在不在商业应用中使用的情况下是免费的。

vmware workstation 下载链接：

VMware-player-full-16.2.0-18760230.zip

链接：https://pan.baidu.com/s/1DsTm2m4zuWEjjTiKliLvkw?pwd=9f3z 提取码：9f3z



还有一个选择是开源虚拟机Virtual Box，支持Linux、Windows、macOS三大系统。

官方主页：https://www.virtualbox.org/





#### 4.3 在虚拟机中安装Linux操作系统

这里我们选择ubuntu Linux Desktop 22.04.4 LTS发行版。**注意：这个版本是经过广泛验证的，一定不要去使用最新的Ubuntu 24。**

下载页面：https://ubuntu.com/download/alternative-downloads

![image-20240705235620653](image/image-20240705235620653.png)

点击“Ubuntu 22.04 LTS(Jammy Jellyfish)”进入下载，选择Desktop image，如下图：

![image-20240705235639975](image/image-20240705235639975.png)

 

如果你连接外网比较慢，也可以选择国内的镜像网站：

https://mirrors.tuna.tsinghua.edu.cn/ubuntu-releases/22.04.4/ubuntu-22.04.4-desktop-amd64.iso

https://mirrors.aliyun.com/ubuntu-releases/jammy/ubuntu-22.04.4-desktop-amd64.iso

 

#### 4.4 Linux 下嵌入式开发工具的安装

需要安装的工具有：

VSCode (包含C++插件、CMake插件、Cortex-Debug插件)  //代码编辑及调试工具

STM32CubeMX 6.1+  //ST的代码生成工具

arm-none-eabi-gcc  //ARM微控制器的C编译器

gcc  //linux下的编译器，用来安装编译软件

make  //编译管理工具

ninja-build  //代替make的编译管理工具

cmake  //工程管理及make脚本自动生成

vim  //文本编辑工具

openocd  //调试接口服务

screen  //linux下terminal下的显示终端，用于连接串口或远程终端

或者cutecom //linux下图形化的串口调试工具

 

##### 4.4.1 首先安装linux工具

执行以下命令安装：

```text-plain
sudo apt update
sudo apt install make ninja-build cmake vim screen gcc cutecom
```

 

##### 4.4.2 下载arm-none-eabi-gcc

可以选择安装编译好的二进制可执行文件包，不需要自己编译。在github搜索xpack，寻找xpack-arm-none-eabi-gcc，主页链接如下：

https://github.com/xpack-dev-tools/arm-none-eabi-gcc-xpack/releases/

选择xpack-arm-none-eabi-gcc-13.2.1-1.1-linux-x64.tar.gz

下载完成后，使用

```text-plain
tar zxvf xpack-arm-none-eabi-gcc-13.2.1-1.1-linux-x64.tar.gz
```

解压，再把解压后的目录整体移动到/opt下备用：

```text-plain
sudo mv ./xpack-arm-none-eabi-gcc-13.2.1-1.1-linux-x64 /opt
```

修改系统环境变量：

```
vim ~/.bashrc
```

将arm-none-eabi-gcc的执行文件目录加入PATH，在.bashrc文件前部添加：

按`i`键进入vim的insert模式，添加：

```
export PATH=$PATH:/opt/xpack-arm-none-eabi-gcc-13.2.1-1.1/bin/
```

按`ESC`键退出"insert"模式 接着输入` :wq` 保存文件并退出。

执行以下命令以更新系统变量：

```
source ~/.bashrc
```

尝试执行：

```shell
arm-none-eabi-gcc -v
```

结果如下：

![image-20240706000454766](image/image-20240706000454766.png)

 

##### 4.4.3 安装openocd

首先在github上搜索xpack，找到xpack-openocd，在release中下载编译好的openocd二进制包

解压后移动到/opt目录下

```
sudo mv /xpack-openocd-0.12.0-3 /opt
```

修改系统环境变量：

```
vim ~/.bashrc
```

将openocd的执行文件目录和配置脚本目录加入PATH：

```
export PATH=$PATH:/opt/xpack-openocd-0.12.0-3/bin/:/opt/xpack-openocd-0.12.0-3/openocd/scripts/
```

先按`ESC` 键退出 "insert" 模式，再输入`:wq` 保存文件并退出vim。

执行以下命令以更新系统变量：

```
source ~/.bashrc
```



##### 4.4.4 安装STM32CubeMX

去ST官网注册一个账号，搜索STM32CubeMX，在产品主页寻找下载，并选择STM32CubeMX_lin_v6.11进行下载。

下载完毕后解压zip文件，执行“SetupSTM32CubeMX-6.11.1”进行安装，安装完毕后程序位于Home/STM32CubeMX/STM32CubeMX，双击即可打开。

打开后，等待几分钟，等软件后台更新完毕后，点击页面右侧"Install or remove embedded software packages"，或者顶部Help菜单下“Manage embedded software packages”，进行器件支持包的安装。如下图：

![image-20240706000744433](image/image-20240706000744433.png)

点开STM32G0，勾选“STM32Cube MCU package for STM32G0 Series version 1.6.2”，如下图：

![image-20240706000811621](image/image-20240706000811621.png)

点击“Install”进行安装，期间会要求你登录ST网站，请填入注册邮箱和密码。

至此安装完毕。

 

##### 4.4.5 安装VSCode

在Linux系统下使用firefox浏览器打开“https://code.visualstudio.com”，在页面左侧选择".deb"按钮进行下载，如图所示：

![image-20240706000849358](image/image-20240706000849358.png)



下载后的文件名为：code_1.90.0-1717531825_amd64.deb， 在Download文件夹下点击鼠标右键选择"Open in terminal"打开命令行窗口，输入：

```text-plain
sudo dpkg -i code_1.90.0-1717531825_amd64.deb
```

进行安装。安装完毕后应该能在Ubuntu的“开始”界面中找到VSCode的图标。双击启动。

启动VSCode后，点击左侧“Extensions”按钮，在上方搜索栏中输入以下内容，搜索相应的拓展插件并安装：

- C/C++
- CMake
- Cortex-Debug

如下图所示：

![image-20240706000931841](image/image-20240706000931841.png)

 

##### 4.4.6 添加开发板/调试器的访问权限

先下载udev的规则文件，我们使用platformio提供的调试器大全，点击以下链接下载rules文件：

https://raw.githubusercontent.com/platformio/platformio-core/develop/platformio/assets/system/99-platformio-udev.rules

使用管理员权限将此文件复制至/etc/udev/rules.d/下：

```
cd ~/Downloads
sudo cp ./99-platformio-udev.rules /etc/udev/rules.d/
```

执行`sudo udevadm trigger`命令激活新的权限

 

##### 4.5 验证

###### 4.5.1 使用USB Type-C电缆连接minisys-G030

上电后应该能看见绿色LED已每秒2次的频率闪烁，同时，橙色LED间歇闪烁。



###### 4.5.2 如果使用原生Linux系统（你的电脑运行的是Linux而不是使用虚拟机），则跳过本步骤。

如果使用虚拟机安装Linux系统，在测试前还需要对VMware Workstation Player做以下操作：

在VMware Workstation Player界面的左上角，点击"Player"，在弹出的菜单中展开"Removable Devices"，查找下方是否存在名为“Keil Software CMSIS-DAP-MuseLab”的设备，并确保该设备前面为打勾的状态，如果没有打勾，点击该设备，在弹出的菜单中勾选Connect(Disconnect from Host)。

![image-20240706104438169](image/image-20240706104438169.png)



然后：

###### 4.5.3 使用Linux工具检查USB连接情况

在终端中输入

```text-plain
lsusb
```

打印usb设备清单，应能看到以下设备：

![image-20240706105343697](image/image-20240706105343697.png)



该设备为minisys-G030板内置的CMSIS-DAP调试器，表明系统已能正常枚举出调试器。

再在终端中输入：

```text-plain
cd /dev
ls |grep ttyACM0
```

此时应有如下显示：

![image-20240706105411112](image/image-20240706105411112.png)

说明可以看到minisys-G030板载的CMSIS-DAP调试器枚举出的另外一个usb虚拟串口的设备。我们可以用这个串口接收STM32G030通过串口打印的调试信息。



###### 4.5.4 在终端中输入：

```text-plain
screen /dev/ttyACM0 115200
```

此时应该不停打印“Hello World!”

或者使用cutecom，以115200的波特率打开/dev/ttyACM0

下方的窗口中应不停的打印Hello World!，如下图：

![image-20240706105454101](image/image-20240706105454101.png)



###### 4.5.5 验证openocd是否正常工作：

使用openocd测试调试器访问。

首先使用USB Type-C电缆连接minisys G030板和计算机，正常应该能看到USB口附件的黄灯闪烁，另一头的绿灯以一秒两次的频率闪烁。在Linux终端中输入：

````
openocd -f interface/cmsis-dap.cfg -f target/stm32g0x.cfg
````

输出的结果应如下图所示：

 ![image-20240706000554661](image/image-20240706000554661.png)

如果依然不能访问，可以重新插拔USB线缆让USB设备重新枚举。

*Test passed under Ubuntu Linux 22.04 @Vmware*



至此，开发用工具基本配置完成。



---

### 五、基于Windows的嵌入式软件开发环境的准备

#### 5.1 安装软件

##### 5.1.1 安装STM32CubeMX

去st官网注册下载STM32CubeMX代码生成工具，安装后再安装一下STM32G0的器件支持包。参见4.4.4.

 

##### 5.1.2 安装Windows下gnu工具集

这个工具集主要是gcc编译所需要的make等工具和仿真linux环境的一些基本命令，常见的windows环境下的gnu工具集很多，有cygwin，mingw等，推荐比较好用又省心的是w64devkit，w64devkit更加完整，包含了gcc，开箱就能用.

w64devkit的下载地址：

https://github.com/skeeto/w64devkit/releases/download/v1.23.0/w64devkit-1.23.0.zip

将以下目录加入系统环境变量：

D:\dev-tools\w64devkit\bin

在Windows搜索栏中搜索`system environment`,在弹出的搜索结果中选择`Edit the system environment variables`(编辑系统环境变量)

![image-20240706113236692](image/image-20240706113236692.png)

在弹出的界面中选择`Environment Variables`(环境变量)

![image-20240706113349275](image/image-20240706113349275.png)

在弹出的界面下方的列表中找到`Path`一行，如下图：

![image-20240706113537901](image/image-20240706113537901.png)

双击弹出编辑界面：

![image-20240706113619476](image/image-20240706113619476.png)

点击`new`(新建)，增加一行新的变量，填入`D:\dev-tools\w64devkit\bin`，这里`D:\dev-tools\`是我电脑上w64devkit所在的目录，这里根据自己的情况修改。

点击`OK`保存设置。

在任意位置点击右键，选择`Open in Terminal`打开Windows Terminal，或者在Windows搜索栏中输入"cmd"，打开命令行提示符界面，输入`make -v`检测是否能够正常执行，如下图所示：

![image-20240706114015530](image/image-20240706114015530.png)

 

##### 5.1.3 安装arm-none-eabi-gcc

为ARM MCU编译程序需要使用专门的跨平台编译器，这里我们使用arm-none-eabi-gcc。这里arm表示支持的是ARM处理器，none-eabi表示这是为裸机系统（bare metal）编译程序，而不是为linux环境编译程序。

arm-none-eabi-gcc下载地址：

https://github.com/xpack-dev-tools/arm-none-eabi-gcc-xpack/releases/download/v13.2.1-1.1/xpack-arm-none-eabi-gcc-13.2.1-1.1-win32-x64.zip

下载后解压至一个目录，如D:\dev-tools\xpack-riscv-none-embed-gcc-10.2.0-1.2\

将以下目录加入系统环境变量：

D:\dev-tools\xpack-riscv-none-embed-gcc-10.2.0-1.2\bin

保存设置。

在任意位置打开Windows Terminal，输入`arm-none-eabi-gcc -v`检测是否能够正常执行，如下图所示：

![image-20240706114348887](image/image-20240706114348887.png)

##### 5.1.5 安装CMake for windows

下载地址：https://cmake.org/download/

选择Binary distributions中的Windows x64 Installer，如下图：

![image-20240706115832167](image/image-20240706115832167.png)

下载后双击安装，一路Next即可。

安装完毕后，在Windows Terminal中输入

```
cmake --version
```

输出应如下图所示：

![image-20240706120037017](image/image-20240706120037017.png)





##### 5.1.4 安装openocd for windows

下载地址：

https://github.com/xpack-dev-tools/openocd-xpack/releases/download/v0.12.0-3/xpack-openocd-0.12.0-3-win32-x64.zip

下载后解压至一个目录，如d:\dev-tools\openocd

将以下目录加入系统环境变量：

D:\dev-tools\xpack-openocd-0.12.0-3\bin

D:\dev-tools\xpack-openocd-0.12.0-3\openocd\scripts

保存设置

在任意位置打开Terminal，输入`openocd -v`检测是否能够正常执行，如下图所示：

![image-20240706114439510](image/image-20240706114439510.png)

连接CMSIS-DAP和目标板，再执行`openocd -f interface\cmsis-dap.cfg -f target\stm32g0x.cfg`，应能够正常连接目标芯片，显示信息如下：

![image-20240706114501384](image/image-20240706114501384.png)

按<kbd>Ctrl</kbd>+<kbd>C</kbd>结束openocd的运行。

至此，openocd工作正常。

##### 5.1.5 安装VSCode以及插件

使用浏览器打开“https://code.visualstudio.com”，在页面左侧选择"Download for Windows"按钮进行下载，如图所示：

![image-20240706114824980](image/image-20240706114824980.png)

安装包下载后，双击exe文件开始安装，一路Next即可。

此外还需要安装以下一些STM32开发所需常用插件：

- Cortex-Debug
- C/C++ Extension Pack
- CMake Tools

这个流程可以参照4.4.5。



#### 5.2 验证

###### 5.2.1 使用STM32CubeMX生成工程



###### 5.2.2 使用VSCode打开工程所在目录



配置cmake，将generator切换为minGW工具（make）。TBD







---

### 参考文献：





















