## 作业三a 基于PN结测温的数字温度计原型系统设计制作与验证

*适用专业：自动化专业*

#### 任务

结合<作业二 PN结测温电路仿真>的成果，并进一步查阅相关资料，基于minisys G030最小系统板和LM358运算放大器及其他元器件，设计一个使用LED数码管作为显示器件的数字温度计。

#### 要求
1、基于LM358和必要的其他元器件，制作一个恒流源，可提供约100uA恒定电流，作为PN结的激励源；
2、LED数码管为四位共阴极数码管，设计制作数码管驱动电路，使用动态扫描方式，尽可能少占用单片机管脚；
3、整个电路采用minisys G030最小系统板上提供的单5V电源供电；
4、数码管的8个笔段可使用单片机PB0~PB7串330欧电阻直接驱动，4个公共阴极使用9013三极管扩流，并使用单片机PD0~PD3驱动，三极管基极需要串一个1k~10k欧电阻限流；
5、运放增益可通过计算，使用固定电阻设定，偏置电压使用电位器调整；

6、参考电压可使用minisys G030的3.3V管脚提供；

7、经过调理的模拟量（0~3.0V或0.2~3.2V）可使用minisys G030的PA0管脚，对应的是单片机的ADC通道0；

8、推荐使用的元器件清单：

- minisys G030
- 排针、排母
- 9013三极管（数码管驱动、测温用PN结）
- 电阻：330Ω、1KΩ、10KΩ
- LM358运算放大器（注意：运放不要直接焊接在实验板上，而是现在实验班上焊接8P插座，再另行安装）

7、参考课程提供的代码，自行编写单片机程序，实现以下功能：

- LED数码管动态扫描显示

- 每秒2次ADC数据采集

- 根据信号调理电路的温度-电压传输函数，计算测得的温度数据，并显示在LED数码管上

  

#### 报告提交

本作业需要提交设计与测试报告。报告中需要给出电路图截图，并标明各个元器件型号与取值。报告中应包含作品实物照片，以及测试过程照片。

作业请在canvas上提交，把你的报告以pdf格式上传。

#### 其他注意事项

本作业不要求温度测量精度，只要能基本符合温度变化趋势，正常显示温度数据即可。

