## 作业三b 基于NTC测温的数字温度计原型系统设计制作与验证

*适用专业：人工智能专业*

#### 任务

进一步查阅相关资料，设计一个使用LED数码管作为显示器件的数字温度计, 使用minisys G030最小系统板上的ADC外设，测试NTC的电阻值并进行转换，得到温度数据。

#### 要求

1、NTC电阻与一个10KΩ固定电阻构成分压网络，并使用单片机ADC(PA0管脚，对应的是单片机的ADC通道0)测量中点电压并反推NTC电阻值；
2、LED数码管为四位共阴极数码管，设计制作数码管驱动电路，使用动态扫描方式，尽可能少占用单片机管脚；
3、整个电路采用minisys G030最小系统板上提供的单5V电源供电；
4、数码管的8个笔段可使用单片机PB0~PB7串330欧电阻直接驱动，4个公共阴极使用9013三极管扩流，并使用单片机PD0~PD3驱动，三极管基极需要串一个1k~10k欧电阻限流；
5、NTC和10KΩ固定电阻使用的参考电压可由minisys G030的3.3V管脚提供；

6、推荐使用的元器件清单：

- minisys G030
- 排针、排母
- 9013三极管（数码管驱动）
- 电阻：330Ω、1KΩ、10KΩ

7、参考课程提供的代码，自行编写单片机程序，实现以下功能：

- LED数码管动态扫描显示
- 每秒2次ADC数据采集
- 电阻值测量计算
- 根据NTC的温度-电阻函数，计算测得的温度数据，并显示在LED数码管上



#### 报告提交

本作业需要提交设计与测试报告。报告中需要给出电路图截图，并标明各个元器件型号与取值。报告中应包含作品实物照片，以及测试过程照片。

作业请在canvas上提交，把你的报告以pdf格式上传。

#### 其他注意事项

本作业不要求温度测量精度，只要能基本符合温度变化趋势，正常显示温度数据即可。

